/*
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.seguridad;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.Perfil;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.entidad.Usuario;
import com.rjconsultores.ventaboletos.service.PerfilService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxPuntoVenta;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderUsuario;
import com.trg.search.Filter;

/**
 * 
 * @author rodrigo
 */
@Controller("busquedaUsuarioController")
@Scope("prototype")
public class BusquedaUsuarioController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;

	@Autowired
	private transient PagedListWrapper<Usuario> plwFormaPago;
	@Autowired
	private PerfilService perfilService;
	private List<Perfil> lsPerfil;
	private MyListbox usuarioList;
	private Paging pagingUsuario;
	private Textbox txtNombUsuario;
	private Textbox txtNombPaterno;
	private Textbox txtNombMaterno;
	private Textbox txtCveUsuario;
	private Textbox txtCveEmpleado;
	private Combobox cmbPerfil;

	private Combobox cmbEmpresa;
	private List<Empresa> lsEmpresas;

	private List<PuntoVenta> lsPuntoVenta;
	private MyComboboxPuntoVenta cmbPuntoVenta;

	public Textbox getTxtCveUsuario() {
		return txtCveUsuario;
	}

	public void setTxtCveUsuario(Textbox txtCveUsuario) {
		this.txtCveUsuario = txtCveUsuario;
	}

	public List<Perfil> getLsPerfil() {
		return lsPerfil;
	}

	public void setLsPerfil(List<Perfil> lsPerfil) {
		this.lsPerfil = lsPerfil;
	}

	public Combobox getCmbPerfil() {
		return cmbPerfil;
	}

	public void setCmbPerfil(Combobox cmbPerfil) {
		this.cmbPerfil = cmbPerfil;
	}

	public Paging getPagingUsuario() {
		return pagingUsuario;
	}

	public void setPagingUsuario(Paging pagingUsuario) {
		this.pagingUsuario = pagingUsuario;
	}

	public Textbox getTxtNombMaterno() {
		return txtNombMaterno;
	}

	public void setTxtNombMaterno(Textbox txtNombMaterno) {
		this.txtNombMaterno = txtNombMaterno;
	}

	public Textbox getTxtNombPaterno() {
		return txtNombPaterno;
	}

	public void setTxtNombPaterno(Textbox txtNombPaterno) {
		this.txtNombPaterno = txtNombPaterno;
	}

	public Textbox getTxtNombUsuario() {
		return txtNombUsuario;
	}

	public void setTxtNombUsuario(Textbox txtNombUsuario) {
		this.txtNombUsuario = txtNombUsuario;
	}

	public MyListbox getUsuarioList() {
		return usuarioList;
	}

	public void setUsuarioList(MyListbox usuarioList) {
		this.usuarioList = usuarioList;
	}

	public Textbox getTxtCveEmpleado() {
		return txtCveEmpleado;
	}

	public void setTxtCveEmpleado(Textbox txtCveEmpleado) {
		this.txtCveEmpleado = txtCveEmpleado;
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		lsPerfil = perfilService.obtenerTodos();

		lsEmpresas = UsuarioLogado.getUsuarioLogado().getEmpresa();
		setLsPuntoVenta(new ArrayList<PuntoVenta>());

		super.doAfterCompose(comp);

		usuarioList.setItemRenderer(new RenderUsuario());
		usuarioList.addEventListener("onDoubleClick", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				Usuario s = (Usuario) usuarioList.getSelected();
				verUsuario(s);
			}
		});

		refreshLista();

		txtCveEmpleado.focus();
	}

	private void verUsuario(Usuario u) {
		if (u == null) {
			return;
		}

		Map args = new HashMap();
		args.put("usuario", u);
		args.put("usuarioList", usuarioList);
		args.put("usrAdmin", Boolean.TRUE);

		openWindow("/gui/seguridad/editarUsuario.zul",
				Labels.getLabel("editarUsuarioController.window.title"), args, MODAL);

	}

	@SuppressWarnings("static-access")
	private void refreshLista() {
		HibernateSearchObject<Usuario> sistemaBusqueda =
				new HibernateSearchObject<Usuario>(Usuario.class,
						pagingUsuario.getPageSize());

		String nombUsuario = txtNombUsuario.getText();
		if (!nombUsuario.equals("")) {
			sistemaBusqueda.addFilterILike("nombusuario", "%" + nombUsuario.trim().concat("%"));
		}

		String nombPaterno = txtNombPaterno.getText();
		if (!nombPaterno.equals("")) {
			sistemaBusqueda.addFilterILike("nombpaterno", "%" + nombPaterno.trim().concat("%"));
		}

		String nombMaterno = txtNombMaterno.getText();
		if (!nombMaterno.equals("")) {
			sistemaBusqueda.addFilterILike("nombmaterno", "%" + nombMaterno.trim().concat("%"));
		}

		String cveUsuario = txtCveUsuario.getText();
		if (cveUsuario != null) {
			sistemaBusqueda.addFilterLike("claveUsuario", "%" + cveUsuario.trim().concat("%"));
		}

		String cveEmpleado = txtCveEmpleado.getText();
		if (!cveEmpleado.equals("")) {
			sistemaBusqueda.addFilterEqual("empleado.cveEmpleado", cveEmpleado.trim());
		}

		Comboitem comboItem = cmbPerfil.getSelectedItem();
		if (comboItem != null) {
			Perfil perfil = (Perfil) comboItem.getValue();

			sistemaBusqueda.addFilterSome("usuarioPerfilList",
					Filter.and(Filter.equal("perfil", perfil),
							Filter.equal("activo", true)));
		}

		List<Empresa> lsEmpresaTmp = null;

		Comboitem itemEmpresa = cmbEmpresa.getSelectedItem();
		if (itemEmpresa != null) {
			Empresa empresa = (Empresa) itemEmpresa.getValue();
			lsEmpresaTmp = new ArrayList<Empresa>();
			lsEmpresaTmp.add(empresa);
		} else {
			lsEmpresaTmp = lsEmpresas;
		}

		sistemaBusqueda.addFilter(Filter.and(Filter.or(
				Filter.some("usuarioEmpresaList",
						Filter.and(Filter.in("empresa", lsEmpresaTmp),
								Filter.equal("activo", true))),
				Filter.not(Filter.some("usuarioEmpresaList", Filter.equal("activo", true))))));

		Comboitem puntoVentaSeleccionada = cmbPuntoVenta.getSelectedItem();

		if (puntoVentaSeleccionada != null) {
			PuntoVenta puntoVenta = (PuntoVenta) puntoVentaSeleccionada.getValue();
			sistemaBusqueda.addFilterSome("usuarioUbicacionList",
					Filter.and(Filter.equal("puntoVenta", puntoVenta),
							Filter.equal("activo", Boolean.TRUE)));
		}

		sistemaBusqueda.addSortAsc("claveUsuario");
		sistemaBusqueda.addFilterEqual("activo", Boolean.TRUE);

		plwFormaPago.init(sistemaBusqueda, usuarioList, pagingUsuario);

		if (usuarioList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("busquedaUsuarioController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
			}
		}
	}

	public void onClick$btnPesquisa(Event ev) {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) {
		refreshLista();
	}

	public void onClick$btnNovo(Event ev) {
		verUsuario(new Usuario());
	}

	public List<PuntoVenta> getLsPuntoVenta() {
		return lsPuntoVenta;
	}

	public void setLsPuntoVenta(List<PuntoVenta> lsPuntoVenta) {
		this.lsPuntoVenta = lsPuntoVenta;
	}

	public Combobox getCmbEmpresa() {
		return cmbEmpresa;
	}

	public void setCmbEmpresa(Combobox cmbEmpresa) {
		this.cmbEmpresa = cmbEmpresa;
	}

	public List<Empresa> getLsEmpresas() {
		return lsEmpresas;
	}

	public void setLsEmpresas(List<Empresa> lsEmpresas) {
		this.lsEmpresas = lsEmpresas;
	}

	public MyComboboxPuntoVenta getCmbPuntoVenta() {
		return cmbPuntoVenta;
	}

	public void setCmbPuntoVenta(MyComboboxPuntoVenta cmbPuntoVenta) {
		this.cmbPuntoVenta = cmbPuntoVenta;
	}
}
